# Class Edge

java.lang.Object
org.jmol.util.Edge

All Implemented Interfaces:
  `SimpleEdge`

Direct Known Subclasses:
  `Bond, SmilesBond`

public abstract class Edge extends Object implements SimpleEdge

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`BOND_AROMATIC`
`static final int`
`BOND_AROMATIC_DOUBLE`
`static final int`
`BOND_AROMATIC_MASK`
`static final int`
`BOND_AROMATIC_SINGLE`
`static final int`
`BOND_COVALENT_DOUBLE`
`static final int`
`BOND_COVALENT_MASK`
`static final int`
`BOND_COVALENT_QUADRUPLE`
`static final int`
`BOND_COVALENT_QUINTUPLE`
`static final int`
`BOND_COVALENT_sextuple`
`static final int`
`BOND_COVALENT_SINGLE`
`static final int`
`BOND_COVALENT_TRIPLE`
`static final int`
`BOND_H_CALC`
`static final int`
`BOND_H_CALC_MASK`
`static final int`
`BOND_H_MINUS_3`
`static final int`
`BOND_H_MINUS_4`
`static final int`
`BOND_H_NUCLEOTIDE`
`static final int`
`BOND_H_PLUS_2`
`static final int`
`BOND_H_PLUS_3`
`static final int`
`BOND_H_PLUS_4`
`static final int`
`BOND_H_PLUS_5`
`static final int`
`BOND_H_REGULAR`
`static final int`
`BOND_HBOND_SHIFT`
`static final int`
`BOND_HYDROGEN_MASK`
`static final int`
`BOND_NEW`
`static final int`
`BOND_ORDER_ANY`
`static final int`
`BOND_ORDER_NULL`
`static final int`
`BOND_ORDER_UNSPECIFIED`
`static final int`
`BOND_PARTIAL01`
`static final int`
`BOND_PARTIAL12`
`static final int`
`BOND_PARTIAL23`
`static final int`
`BOND_PARTIAL32`
`static final int`
`BOND_PYMOL_MULT`
`static final int`
`BOND_PYMOL_SCALE`
`static final int`
`BOND_RENDER_MASK`
Extended Bond Definition Types Originally these were short 16-bit values
`static final int`
`BOND_RENDER_SINGLE`
`static final int`
`BOND_STEREO_EITHER`
`static final int`
`BOND_STEREO_FAR`
`static final int`
`BOND_STEREO_NEAR`
`static final int`
`BOND_STRUT`
`static final int`
`BOND_SULFUR_MASK`
`int`
`index`
`int`
`order`
`static final int`
`TYPE_ATROPISOMER`
`static final int`
`TYPE_ATROPISOMER_REV`

## Constructor Summary

Constructors
Constructor
Description
`Edge()`

## Method Summary

Modifier and Type
Method
Description
`static int`
`getArgbHbondType(int order)`
`abstract int`
`getAtomIndex1()`
`abstract int`
`getAtomIndex2()`
`static Node`
`getAtropismNode(int order, Node a1, boolean isFirst)`
`static int`
`getAtropismOrder(int nn, int mm)`
`static int`
`getAtropismOrder12(int nnmm)`
`static final int`
`getBondOrderFromFloat(float fOrder)`
`static int`
`getBondOrderFromString(String s)`
Encode name such as 1 2 3 2.1 3.1 single double triple atropisomer_12 or "partial 1.3"
`static final String`
`getBondOrderNameFromOrder(int order)`
`static final String`
`getBondOrderNumberFromOrder(int order)`
used for formatting labels and in the connect PARTIAL command
`int`
`getBondType()`
Get the order of the bond.
`String`
`getCIPChirality(boolean doCalculate)`
`static final String`
`getCmlBondOrder(int order)`
`protected static final int`
`getCovalentBondOrder(int order)`
`abstract int`
`getCovalentOrder()`
`static int`
`getFloatEncodedInt(String strDecimal)`
Encodes a string such as "2.10" as an integer instead of a double so as to distinguish "2.1" from "2.10".
`static final int`
`getPartialBondDotted(int order)`
`static final int`
`getPartialBondOrder(int order)`
`static int`
`getPartialBondOrderFromFloatEncodedInt(int bondOrderInteger)`
reads standard n.m double-as-integer (n*1000000 + m) and returns partial bond order as (n % 7) invalid input: '<'invalid input: '<' 5 + (m % 0x1F)
`static boolean`
`isAtropism(int order)`
`abstract boolean`
`isCovalent()`
`abstract boolean`
`isHydrogen()`
`static boolean`
`isOrderH(int order)`
`boolean`
`isPartial()`
`boolean`
`isStereo()`
`void`
`setCIPChirality(int c)`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface SimpleEdge

`getAtom, getOtherNode`

## Field Details

### BOND_RENDER_MASK

public static final int BOND_RENDER_MASK
Extended Bond Definition Types Originally these were short 16-bit values

See Also:
  - Constant Field Values

### BOND_RENDER_SINGLE

public static final int BOND_RENDER_SINGLE

See Also:
  - Constant Field Values

### TYPE_ATROPISOMER

public static final int TYPE_ATROPISOMER

See Also:
  - Constant Field Values

### TYPE_ATROPISOMER_REV

public static final int TYPE_ATROPISOMER_REV

See Also:
  - Constant Field Values

### BOND_STEREO_NEAR

public static final int BOND_STEREO_NEAR

See Also:
  - Constant Field Values

### BOND_STEREO_FAR

public static final int BOND_STEREO_FAR

See Also:
  - Constant Field Values

### BOND_STEREO_EITHER

public static final int BOND_STEREO_EITHER

See Also:
  - Constant Field Values

### BOND_AROMATIC_MASK

public static final int BOND_AROMATIC_MASK

See Also:
  - Constant Field Values

### BOND_AROMATIC_SINGLE

public static final int BOND_AROMATIC_SINGLE

See Also:
  - Constant Field Values

### BOND_AROMATIC_DOUBLE

public static final int BOND_AROMATIC_DOUBLE

See Also:
  - Constant Field Values

### BOND_AROMATIC

public static final int BOND_AROMATIC

See Also:
  - Constant Field Values

### BOND_SULFUR_MASK

public static final int BOND_SULFUR_MASK

See Also:
  - Constant Field Values

### BOND_PARTIAL01

public static final int BOND_PARTIAL01

See Also:
  - Constant Field Values

### BOND_PARTIAL12

public static final int BOND_PARTIAL12

See Also:
  - Constant Field Values

### BOND_PARTIAL23

public static final int BOND_PARTIAL23

See Also:
  - Constant Field Values

### BOND_PARTIAL32

public static final int BOND_PARTIAL32

See Also:
  - Constant Field Values

### BOND_COVALENT_MASK

public static final int BOND_COVALENT_MASK

See Also:
  - Constant Field Values

### BOND_COVALENT_SINGLE

public static final int BOND_COVALENT_SINGLE

See Also:
  - Constant Field Values

### BOND_COVALENT_DOUBLE

public static final int BOND_COVALENT_DOUBLE

See Also:
  - Constant Field Values

### BOND_COVALENT_TRIPLE

public static final int BOND_COVALENT_TRIPLE

See Also:
  - Constant Field Values

### BOND_COVALENT_QUADRUPLE

public static final int BOND_COVALENT_QUADRUPLE

See Also:
  - Constant Field Values

### BOND_COVALENT_QUINTUPLE

public static final int BOND_COVALENT_QUINTUPLE

See Also:
  - Constant Field Values

### BOND_COVALENT_sextuple

public static final int BOND_COVALENT_sextuple

See Also:
  - Constant Field Values

### BOND_ORDER_UNSPECIFIED

public static final int BOND_ORDER_UNSPECIFIED

See Also:
  - Constant Field Values

### BOND_ORDER_ANY

public static final int BOND_ORDER_ANY

See Also:
  - Constant Field Values

### BOND_ORDER_NULL

public static final int BOND_ORDER_NULL

See Also:
  - Constant Field Values

### BOND_STRUT

public static final int BOND_STRUT

See Also:
  - Constant Field Values

### BOND_PYMOL_MULT

public static final int BOND_PYMOL_MULT

See Also:
  - Constant Field Values

### BOND_PYMOL_SCALE

public static final int BOND_PYMOL_SCALE

See Also:
  - Constant Field Values

### BOND_NEW

public static final int BOND_NEW

See Also:
  - Constant Field Values

### BOND_HBOND_SHIFT

public static final int BOND_HBOND_SHIFT

See Also:
  - Constant Field Values

### BOND_HYDROGEN_MASK

public static final int BOND_HYDROGEN_MASK

See Also:
  - Constant Field Values

### BOND_H_REGULAR

public static final int BOND_H_REGULAR

See Also:
  - Constant Field Values

### BOND_H_CALC_MASK

public static final int BOND_H_CALC_MASK

See Also:
  - Constant Field Values

### BOND_H_CALC

public static final int BOND_H_CALC

See Also:
  - Constant Field Values

### BOND_H_PLUS_2

public static final int BOND_H_PLUS_2

See Also:
  - Constant Field Values

### BOND_H_PLUS_3

public static final int BOND_H_PLUS_3

See Also:
  - Constant Field Values

### BOND_H_PLUS_4

public static final int BOND_H_PLUS_4

See Also:
  - Constant Field Values

### BOND_H_PLUS_5

public static final int BOND_H_PLUS_5

See Also:
  - Constant Field Values

### BOND_H_MINUS_3

public static final int BOND_H_MINUS_3

See Also:
  - Constant Field Values

### BOND_H_MINUS_4

public static final int BOND_H_MINUS_4

See Also:
  - Constant Field Values

### BOND_H_NUCLEOTIDE

public static final int BOND_H_NUCLEOTIDE

See Also:
  - Constant Field Values

### index

public int index

### order

public int order

## Constructor Details

### Edge

public Edge()

## Method Details

### getAtomIndex1

public abstract int getAtomIndex1()

### getAtomIndex2

public abstract int getAtomIndex2()

### getCovalentOrder

public abstract int getCovalentOrder()

Specified by:
  `getCovalentOrder` in interface `SimpleEdge`
Returns:
  the bond order 1-4 if it is covalent, or 0 if not.

### isCovalent

public abstract boolean isCovalent()

Specified by:
  `isCovalent` in interface `SimpleEdge`

### isHydrogen

public abstract boolean isHydrogen()

### isPartial

public boolean isPartial()

### isStereo

public boolean isStereo()

### getArgbHbondType

public static int getArgbHbondType(int order)

### getBondOrderNumberFromOrder

public static final String getBondOrderNumberFromOrder(int order)
used for formatting labels and in the connect PARTIAL command

Parameters:
  `order` -
Returns:
  a string representation to preserve float n.m

### getCmlBondOrder

public static final String getCmlBondOrder(int order)

### getBondOrderNameFromOrder

public static final String getBondOrderNameFromOrder(int order)

### getAtropismOrder

public static int getAtropismOrder(int nn, int mm)

### getAtropismOrder12

public static int getAtropismOrder12(int nnmm)

### getAtropismNode

public static Node getAtropismNode(int order, Node a1, boolean isFirst)

### isAtropism

public static boolean isAtropism(int order)

### isOrderH

public static boolean isOrderH(int order)

### getPartialBondDotted

public static final int getPartialBondDotted(int order)

### getPartialBondOrder

public static final int getPartialBondOrder(int order)

### getCovalentBondOrder

protected static final int getCovalentBondOrder(int order)

### getBondOrderFromFloat

public static final int getBondOrderFromFloat(float fOrder)

### getBondOrderFromString

public static int getBondOrderFromString(String s)
Encode name such as 1 2 3 2.1 3.1 single double triple atropisomer_12 or "partial 1.3"

Parameters:
  `s` -
Returns:
  encoded form of bond

### getPartialBondOrderFromFloatEncodedInt

public static int getPartialBondOrderFromFloatEncodedInt(int bondOrderInteger)
reads standard n.m double-as-integer (n*1000000 + m) and returns partial bond order as (n % 7) invalid input: '<'invalid input: '<' 5 + (m % 0x1F)

Parameters:
  `bondOrderInteger` -
Returns:
  partial bond order encoded as an integer

### getFloatEncodedInt

public static int getFloatEncodedInt(String strDecimal)
Encodes a string such as "2.10" as an integer instead of a double so as to distinguish "2.1" from "2.10". For n.m, returns n * 1000000 + m. 2147483647 is maxvalue, so this allows an encoding of up to n = 2147 and m = 999999 Used in Jmol for model numbers and partial bond orders.

Parameters:
  `strDecimal` -
Returns:
  double encoded as an integer

### getBondType

public int getBondType()
Description copied from interface: `SimpleEdge`
Get the order of the bond. This could be covalent order, but also could be NEAR, FAR, etc.

Specified by:
  `getBondType` in interface `SimpleEdge`
Returns:
  order

### setCIPChirality

public void setCIPChirality(int c)

Parameters:
  `c` -

### getCIPChirality

public String getCIPChirality(boolean doCalculate)

Parameters:
  `doCalculate` -
Returns:
  CIP chirality label